
/*
 * An array has
 *  - a base type (int, float or string)
 *  - a list with dimensions (incl. number of dimensions)
 *  - a buffer where the elements are stored
 */

typedef struct {
  int ndim;       // number of dimensions
  int *dim;       // list with dimensions
} Array;


void *get_array_elem(Array *a, int *index)
{
  // the buffer begins after the array struct
  void *buf = (void *) a + (ndim + 1) * sizeof(int);
  pos = index[0];

  for(i = 1; i < ndim; i++)
    pos = pos * dim[i] + index[i];
}


int *get_array_elem(IntArray *array, int *index)
{
  pos = index[0];
  for(int i = 1; i < array->ndim; i++)
    pos = pos * array->dim[i] + index[i];
  // pointer arithmetic: array->buf is an int pointer
  return array->buf + pos;
}


/*
 * Returns address of array element.
 * Parsing, calculation of address and index check are mixed here.
 */
int *getArrayElement(...)
{
  // so far the opening bracket '(' has been read, so sval still contains
  // the array name
  Array *array = arrays.lookup(sval);
  if(!array)
    error(14, "Unknown array");
  nextToken(); // skip '('
  // read subscript list
  int subscript = int_expression();
  if(subscript < 0 || subscript > array->dim[i])
    error(15, "Subscript out of range");
  int pos = subscript;
  int i = 1;
  while(ttype == ',') {
    nextToken();
    if(i > array->ndim)
      error(15, "Incorrect number of subscripts");
    nextToken();
    subscript = int_expression();
    if(subscript < 0 || subscript > array->dim[i])
      error(15, "Subscript out of range");
    pos = pos * (array->dim[i] + 1) + subscript;
    i++;
  }
  expect(')');
  if(i != array->ndim)
    error(15, "Incorrect number of subscripts");

  return array->buf + pos;
}


// Can an array have the same name as a scalar variable?

void factor(Object *val)
{
  //...
  case TT_IDENTIFIER:
    // save sval
    char temp[32];
    strcpy(temp, sval);
    //printf("getVariable: %s -> %d\n", sval, val->intValue);
    nextToken();
//     if(ttype == '(')
//       getArrayElement(...);
//     else
      getVariable(temp, val);
    break;
}


void exec_dim()
{
  int dim[10];  // need dynamic array / list!

  nextToken();  // skip DIM
  if(ttype != TT_IDENTIFIER)
    error(-1, "Identifier expected after DIM");
  if(arrays.get(sval))
    error(10, "Arrays cannot be redimensioned");
  strcpy(temp, sval);  // save sval
  nextToken();
  expect('(');
  dim[0] = int_expression();
  if(dim[0] < 0)
    error(-1, "Dimension must be greater than zero");
  int n = 1;
  int size = dim[0] + 1;
  while(ttype == ',') {
    nextToken();
    dim[n] = int_expression();
    if(dim[n] < 0)
      error(-1, "Dimension must be greater than zero");
    size *= (dim[n] + 1);
    n++;
  }
  expect(')');
  Array *array = (Array *) malloc((n + 1 + size) * sizeof(int));  // oder so...
  arrays.put(temp, array);
}


