
#include "SymbolTable.h"
#include "Stack.h"


// array with pointers to lines
extern char *lines[];

// global symbol table
extern SymbolTable symbols;
extern Stack stack;

// current line number
extern int lineno;

// pointer to current line
extern const char *line;

extern bool quit;
extern bool end;



void error(int num, const char *msg, ...);
void getVariable(const char *name, Object *val);
void assign(Object *dest, Object *val);
void assign(const char *name, Object *val);
void ensure_eos();
void expect(int token, int code, const char *msg);
void expect(int token);
void jump_to(int l, char *p);
int interpret_statement();
void interpret_line(const char *l);
void load(const char *filename);
void list();
void run();


// ---- variable name categories ----

/*
 *  Tests if the identifier ends with a '%'.
 */
inline bool isInteger(const char *id)
{
  return id[strlen(id) - 1] == '%';
}

/*
 *  Tests if the identifier doesn't end with a '$' or '%'.
 */
inline bool isFloat(const char *id)
{
  char c = id[strlen(id) - 1];
  return c != '$' && c != '%';
}

/*
 *  Tests if the identifier ends with a '$'.
 */
inline bool isString(const char *id)
{
  return id[strlen(id) - 1] == '$';
}
