/*
 *  Character / String handling keywords.
 *
 *  String handling has to be completely rewritten if we want to allow
 *  strings containing the null character :-(
 */


#include <stdio.h>
#include <string.h>  // strdup

#include "Object.h"
#include "arg.h"
#include "expr.h"
#include "lex.h"  // nextToken()
#include "token.h"


void exec_asc(Object *res)
{
  char *s = string_factor();
  res->setInt(s[0] ? (int) s[0] : -1);
}


void exec_chrString(Object *res)
{
  char buf[2];

  int code = int_factor();
  buf[0] = (char) code;  // check for EOF
  buf[1] = '\0';

  res->setString(strdup(buf));
}


void exec_instr(Object *res)
{
  int start = 1;

  expect('(');
  char *s1 = string_expression();
  expect(',');
  char *s2 = string_expression();
  if(ttype == ',') {
    nextToken();
    start = int_expression();
  }
  expect(')');

  char *t = strstr(s1 + start - 1, s2);

  res->setInt(t ? t - s1 + 1 : 0);
}

